'use strict';

var shareKit = require('@bloomprotocol/share-kit');
var tslib_1 = require('tslib');
var vuePropertyDecorator = require('vue-property-decorator');

function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;
  subClass.__proto__ = superClass;
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

exports.RequestElement =
/*#__PURE__*/
function (_Vue) {
  _inheritsLoose(RequestElement, _Vue);

  function RequestElement() {
    var _this;

    _this = _Vue.apply(this, arguments) || this;
    _this.requestElementResult = null;
    return _this;
  }

  var _proto = RequestElement.prototype;

  _proto.mounted = function mounted() {
    if (!this.$refs.containerRef) return;
    var requestData = this.requestData,
        shouldRenderButton = this.shouldRenderButton,
        qrOptions = this.qrOptions,
        buttonOptions = this.buttonOptions;
    this.requestElementResult = shareKit.renderRequestElement({
      container: this.$refs.containerRef,
      requestData: requestData,
      qrOptions: qrOptions,
      shouldRenderButton: shouldRenderButton,
      buttonOptions: buttonOptions
    });
  };

  _proto.onPropertyChanged = function onPropertyChanged() {
    if (!this.requestElementResult) return;
    var requestData = this.requestData,
        qrOptions = this.qrOptions,
        buttonOptions = this.buttonOptions;
    this.requestElementResult.update({
      requestData: requestData,
      qrOptions: qrOptions,
      buttonOptions: buttonOptions
    });
  };

  _proto.beforeDestroy = function beforeDestroy() {
    if (this.requestElementResult) {
      this.requestElementResult.remove();
    }
  };

  _proto.render = function render(h) {
    var requestData = this.requestData,
        shouldRenderButton = this.shouldRenderButton,
        qrOptions = this.qrOptions,
        buttonOptions = this.buttonOptions,
        rest = _objectWithoutPropertiesLoose(this, ["requestData", "shouldRenderButton", "qrOptions", "buttonOptions"]);

    return h("div", Object.assign({}, rest, {
      ref: "containerRef"
    }));
  };

  return RequestElement;
}(vuePropertyDecorator.Vue);

tslib_1.__decorate([vuePropertyDecorator.Prop(), tslib_1.__metadata("design:type", Object)], exports.RequestElement.prototype, "requestData", void 0);

tslib_1.__decorate([vuePropertyDecorator.Prop(), tslib_1.__metadata("design:type", Object)], exports.RequestElement.prototype, "qrOptions", void 0);

tslib_1.__decorate([vuePropertyDecorator.Prop(), tslib_1.__metadata("design:type", Function)], exports.RequestElement.prototype, "shouldRenderButton", void 0);

tslib_1.__decorate([vuePropertyDecorator.Prop(), tslib_1.__metadata("design:type", Object)], exports.RequestElement.prototype, "buttonOptions", void 0);

tslib_1.__decorate([vuePropertyDecorator.Watch('requestData'), vuePropertyDecorator.Watch('qrOptions'), vuePropertyDecorator.Watch('buttonOptions'), tslib_1.__metadata("design:type", Function), tslib_1.__metadata("design:paramtypes", []), tslib_1.__metadata("design:returntype", void 0)], exports.RequestElement.prototype, "onPropertyChanged", null);

exports.RequestElement =
/*#__PURE__*/
tslib_1.__decorate([vuePropertyDecorator.Component], exports.RequestElement);

Object.keys(shareKit).forEach(function (key) {
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return shareKit[key];
    }
  });
});
//# sourceMappingURL=share-kit-vue.cjs.development.js.map
