import { renderRequestElement } from '@bloomprotocol/share-kit';
export * from '@bloomprotocol/share-kit';
import { __decorate, __metadata } from 'tslib';
import { Prop, Watch, Component, Vue } from 'vue-property-decorator';

function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;
  subClass.__proto__ = superClass;
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

var RequestElement =
/*#__PURE__*/
function (_Vue) {
  _inheritsLoose(RequestElement, _Vue);

  function RequestElement() {
    var _this;

    _this = _Vue.apply(this, arguments) || this;
    _this.requestElementResult = null;
    return _this;
  }

  var _proto = RequestElement.prototype;

  _proto.mounted = function mounted() {
    if (!this.$refs.containerRef) return;
    var requestData = this.requestData,
        shouldRenderButton = this.shouldRenderButton,
        qrOptions = this.qrOptions,
        buttonOptions = this.buttonOptions;
    this.requestElementResult = renderRequestElement({
      container: this.$refs.containerRef,
      requestData: requestData,
      qrOptions: qrOptions,
      shouldRenderButton: shouldRenderButton,
      buttonOptions: buttonOptions
    });
  };

  _proto.onPropertyChanged = function onPropertyChanged() {
    if (!this.requestElementResult) return;
    var requestData = this.requestData,
        qrOptions = this.qrOptions,
        buttonOptions = this.buttonOptions;
    this.requestElementResult.update({
      requestData: requestData,
      qrOptions: qrOptions,
      buttonOptions: buttonOptions
    });
  };

  _proto.beforeDestroy = function beforeDestroy() {
    if (this.requestElementResult) {
      this.requestElementResult.remove();
    }
  };

  _proto.render = function render(h) {
    var requestData = this.requestData,
        shouldRenderButton = this.shouldRenderButton,
        qrOptions = this.qrOptions,
        buttonOptions = this.buttonOptions,
        rest = _objectWithoutPropertiesLoose(this, ["requestData", "shouldRenderButton", "qrOptions", "buttonOptions"]);

    return h("div", Object.assign({}, rest, {
      ref: "containerRef"
    }));
  };

  return RequestElement;
}(Vue);

__decorate([Prop(), __metadata("design:type", Object)], RequestElement.prototype, "requestData", void 0);

__decorate([Prop(), __metadata("design:type", Object)], RequestElement.prototype, "qrOptions", void 0);

__decorate([Prop(), __metadata("design:type", Function)], RequestElement.prototype, "shouldRenderButton", void 0);

__decorate([Prop(), __metadata("design:type", Object)], RequestElement.prototype, "buttonOptions", void 0);

__decorate([Watch('requestData'), Watch('qrOptions'), Watch('buttonOptions'), __metadata("design:type", Function), __metadata("design:paramtypes", []), __metadata("design:returntype", void 0)], RequestElement.prototype, "onPropertyChanged", null);

RequestElement =
/*#__PURE__*/
__decorate([Component], RequestElement);

export { RequestElement };
//# sourceMappingURL=share-kit-vue.esm.js.map
